v7.3.0

Binding Bryntum Scheduler data

Bryntum Scheduler is a data intensive component that uses several datasets. These datasets usually come from the server and are held in Scheduler project during the lifetime of the Scheduler view. There are several ways of populating the project data stores.

Using CrudManager transport

CrudManager is a built-in class that implements loading and saving of data in multiple stores with transport config. Loading the stores and saving all changes is done in one request.

Configuring crudManager with transport is the simplest way of binding data to the Scheduler project stores as seen from the client side, but it does require following a specific protocol on the backend.

The configuration of crudManager can be as simple as:

crudManager : {
    transport : {
        load : {
            url : '/server/load/url'
        },
        sync : {
            url : '/server/save/url'
        }
    },
    autoLoad : true
}

With this configuration, the data is loaded and saved from and to the above URLs and the data transport is handled automatically.

Binding existing data to the component

When the application already has a server transport layer then the data for Scheduler is available in application code and it needs to be passed (bound) to the component. One approach is to make the data available as component variables and bind them in the Vue template:

App.vue:

<template>
    <bryntum-scheduler
        :assignments = "assignments"
        :dependencies = "dependencies"
        :resources = "resources"
        :events = "events"
        v-bind = schedulerProps
    />
</template>

<script>
import { ref, reactive } from 'vue';

import { BryntumScheduler } from '@bryntum/scheduler-vue-3';

import { useSchedulerProps } from '@/AppConfig';
import * as appData from '@/AppData';

export default {
    name : 'App',

    components : {
        BryntumScheduler
    },

    setup() {
        const schedulerProps = reactive(useSchedulerProps());

        const assignments = ref(appData.assignments);
        const dependencies = ref(appData.dependencies);
        const resources = ref(appData.resources);
        const events = ref(appData.events);

        return {
            schedulerProps,
            assignments,
            dependencies,
            resources,
            events
        };
    }
};
</script>

<style lang = "scss">
@import './App.scss';
</style>

Here we have component variables, initialized by spreading ...initialData. Whenever a change of the data is needed, it is only necessary to assign the new values to these variables, for example:

this.events = newEvents;
this.dependencies = newDependencies;

Binding existing data to the project

This approach binds data to a standalone SchedulerProjectModel and then uses this project in Scheduler. Project has its own markup in the template and it must be assigned to the Scheduler during initialization.

This approach is suitable for more complex applications that use more than one Bryntum component that share a common project:

App.vue:

<template>
    <div>
        <bryntum-scheduler-project-model
            ref = "project"
            :assignments = "assignments"
            :dependencies = "dependencies"
            :resources = "resources"
            :events = "events"
        />
        <bryntum-scheduler
            :project = "project"
            v-bind = schedulerProps
        />
    </div>
</template>

<script>
import { ref, reactive } from 'vue';

import { BryntumSchedulerProjectModel, BryntumScheduler } from '@bryntum/scheduler-vue-3';

import { useSchedulerProps } from '@/AppConfig';
import * as appData from '@/AppData';

export default {
    name : 'App',

    components : {
        BryntumSchedulerProjectModel,
        BryntumScheduler
    },

    setup() {
        const project = ref(null);

        constschedulerProps = reactive(useSchedulerProps());

        const assignments = ref(appData.assignments);
        const dependencies = ref(appData.dependencies);
        const resources = ref(appData.resources);
        const events = ref(appData.events);

        return {
            project,
           schedulerProps,
            assignments,
            dependencies,
            events,
            resources
        };
    }
};
</script>

<style lang = "scss">
@import './App.scss';
</style>

Here we create a standalone SchedulerProjectModel (without any rendered output) with properties bound to individual data sets.

Note that bryntum-scheduler-project-model tag must come before all other components that use it. Otherwise the project reference is not valid to these components.

Contents

v7.3.0

Binding Bryntum Scheduler data

Bryntum Scheduler is a data intensive component that uses several datasets. These datasets usually come from the server and are held in Scheduler project during the lifetime of the Scheduler view. There are several ways of populating the project data stores.

Using CrudManager transport

CrudManager is a built-in class that implements loading and saving of data in multiple stores with transport config. Loading the stores and saving all changes is done in one request.

Configuring crudManager with transport is the simplest way of binding data to the Scheduler project stores as seen from the client side, but it does require following a specific protocol on the backend.

The configuration of crudManager can be as simple as:

crudManager : {
    transport : {
        load : {
            url : '/server/load/url'
        },
        sync : {
            url : '/server/save/url'
        }
    },
    autoLoad : true
}

With this configuration, the data is loaded and saved from and to the above URLs and the data transport is handled automatically.

Binding existing data to the component

When the application already has a server transport layer then the data for Scheduler is available in application code and it needs to be passed (bound) to the component. One approach is to make the data available as state variables and set these as properties of the React component:

App.js:

import React, { useState } from 'react';

import { schedulerProps } from './AppConfig';
import { projectData } from './AppData';

import './App.scss';

function App() {
    const [events, setEvents] = useState(projectData.events);
    const [assignments, setAssignments] = useState(projectData.assignments);
    const [dependencies, setDependencies] = useState(projectData.dependencies);
    const [resources, setResources] = useState(projectData.resources);

    return (
        <BryntumScheduler
            ref = {scheduler}
            events = {events}
            assignments = {assignments}
            dependencies = {dependencies}
            resources = {resources}
            {...schedulerProps}
        />
    );
}

export default App;

Here we have state variables, one per data set, together with their setters so whenever a change of data is needed the setter needs to be called with new data as the argument and the change will be immediately reflected in the Scheduler.

For example:

setEvents(newEvents);
setResources(newResources);
When binding to data, the same principles as for React state applies - an object in the incoming data must be replaced instead of mutated for a change to be detected ( explained by the React team here).

If you cannot follow best practise and have to mutate the objects, you can configure the underlying store with useRawData: false. It will then clone the incoming objects and can thus detect mutations when state is reapplied, trading performance for flexibility (docs here).

Binding existing data to the project

This approach binds data to a standalone SchedulerProjectModel and then uses this project in Scheduler. Project has its own markup in the template and it must be assigned to the Scheduler during initialization.

This approach is suitable for more complex applications that use more than one Bryntum component that share a common project:

App.js:

import React, { useState, useRef } from 'react';

import { schedulerProps, projectProps } from './AppConfig';
import { projectData } from './AppData';

import './App.scss';

function App() {
    const scheduler = useRef();
    const project = useRef();

    const [events] = useState(projectData.events);
    const [assignments] = useState(projectData.assignments);
    const [dependencies] = useState(projectData.dependencies);
    const [resources] = useState(projectData.resources);

    return (
        <>
            <BryntumSchedulerProjectModel
                ref = {project}
                events = {events}
                assignments = {assignments}
                dependencies = {dependencies}
                resources = {resources}
                {...projectProps}
            />
            <BryntumScheduler
                ref = {scheduler}
                project = {project}
                {...schedulerProps}
            />
        </>
    );
}

export default App;

Here we create a standalone SchedulerProjectModel (without any rendered output) with properties bound to individual data sets. The project must be assigned to Scheduler in useEffect which is configured to run only once on component mount.

Note that BryntumSchedulerProjectModel must be returned first for other components to use it. Otherwise the Scheduler appears blank, without any data.

Working with Redux

Bryntum components can also be integrated with a Redux Store using the same workflow that you would use to manage the state of a traditional React project.

To see this in action, you can try out our Bryntum Taskboard React + Redux demo.

Contents

v7.3.0

Binding Bryntum Scheduler data

Bryntum Scheduler is a data intensive component that uses several datasets. These datasets usually come from the server and are held in Scheduler project during the lifetime of the Scheduler view. There are several ways of populating the project data stores.

Using CrudManager transport

CrudManager is a built-in class that implements loading and saving of data in multiple stores with transport config. Loading the stores and saving all changes is done in one request.

Configuring crudManager with transport is the simplest way of binding data to the Scheduler project stores as seen from the client side, but it does require following a specific protocol on the backend.

The configuration of crudManager can be as simple as:

crudManager : {
    transport : {
        load : {
            url : '/server/load/url'
        },
        sync : {
            url : '/server/save/url'
        }
    },
    autoLoad : true
}

With this configuration, the data is loaded and saved from and to the above URLs and the data transport is handled automatically.

Binding existing data to the component

When the application already has a server transport layer then the data for Scheduler is available in application code and it needs to be passed (bound) to the component. One approach is to make the data available as Angular component class variables and then use them in templates:

app.ts:

import { Component, OnInit } from '@angular/core';
import { schedulerProps } from './app.config';
import { DataService } from './data.service';

@Component({
    selector    : 'app-root',
    templateUrl : './app.component.html',
    styleUrls   : ['./app.component.scss'],
    providers   : [DataService]
})
export class App implements OnInit {

    events = [];
    dependencies = [];
    resources = [];
    assignments = [];
    timeRanges = [];

    schedulerProps = schedulerProps;

    // Inject data service
    constructor(private dataService: DataService) {}

    ngOnInit(): void {
        // Get initial data
        Object.assign(this, this.dataService.getData());
    }
}

app.html:

<bryntum-scheduler
    #scheduler
    [columns] = "schedulerProps.columns!"
    [assignments] = "assignments"
    [dependencies] = "dependencies"
    [events] = "events"
    [resources] = "resources"
    [timeRanges] = "timeRanges"
></bryntum-scheduler>

DataService is a placeholder name in this example and it would be replaced by the service that provides data in your application.

The key is to supply existing data to the class variables and then use these variables in the template.

Binding existing data to the project

This approach binds data to a standalone SchedulerProjectModel component and then uses this project in Scheduler. Project has its own markup in the template and it must be assigned to the Scheduler during initialization.

This approach is suitable for more complex applications that use more than one Bryntum component that share a common project:

app.ts:

import { Component, OnInit } from '@angular/core';
import { schedulerProps, projectProps } from './app.config';
import { DataService } from './data.service';

@Component({
    selector    : 'app-root',
    templateUrl : './app.component.html',
    styleUrls   : ['./app.component.scss'],
    providers   : [DataService]
})
export class App implements OnInit {

    events = [];
    dependencies = [];
    resources = [];
    assignments = [];
    timeRanges = [];

    schedulerProps = schedulerProps;
    projectProps = projectProps;

    // Inject data service
    constructor(private dataService: DataService) {}

    ngOnInit(): void {
        // Get initial data
        Object.assign(this, this.dataService.getData());
    }
}

app.html:

<bryntum-scheduler-project-model
    #project
    [startDate] = "projectProps.startDate!"
    [assignments] = "assignments"
    [dependencies] = "dependencies"
    [events] = "events"
    [resources] = "resources"
    [timeRanges] = "timeRanges"
></bryntum-scheduler-project-model>

<bryntum-scheduler
    #scheduler
    [columns] = "schedulerProps.columns!"
    [project] = "project"
></bryntum-scheduler>
Note that bryntum-scheduler-project-model tag must come before all other components that use it. Otherwise the #project reference is not valid to these components.

DataService is a placeholder name in this example and it would be replaced by the service that provides data in your application.

Contents